"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* global fetch */
require("./patches");
const utils_1 = require("./utils");
const expo_jwt_1 = __importDefault(require("expo-jwt"));
// Seald SDK
require("@seald-io/sdk/lib/declarations");
const main_js_1 = require("@seald-io/sdk/lib/main.js");
const sscryptoForge = __importStar(require("sscrypto/forge"));
const sscryptoWebcrypto = __importStar(require("sscrypto/webcrypto"));
// SDK local database
const nedbclient_1 = __importDefault(require("follicle/build/lib/clients/nedbclient"));
const algorithms_1 = require("expo-jwt/dist/types/algorithms");
const createNeDbClient = (databasePath, serializationHooks) => nedbclient_1.default.connect(databasePath || 'nedb://memory', serializationHooks);
const signJWT = async (payload, secret) => {
    return expo_jwt_1.default.encode(payload, secret, { algorithm: algorithms_1.SupportedAlgorithms.HS256 });
};
exports.default = ({ apiURL, hairlessURL, appId, nedbClient, databasePath, databaseKey, databaseRawKey, shouldWaterfallApi, plugins, libPhoneNumber, keySize, createEncryptionSessionCache, encryptionSessionCacheTTL }) => {
    return (0, main_js_1.SDK)({
        fetch,
        sscrypto: (0, utils_1.isChromeDebugger)() ? sscryptoWebcrypto : sscryptoForge,
        nedbClient,
        createNeDbClient,
        databasePath,
        databaseKey,
        databaseRawKey,
        apiURL,
        hairlessURL,
        appId,
        shouldWaterfallApi,
        plugins,
        scrypt: utils_1.scrypt,
        signJWT,
        getRSAKeyPromise: (0, utils_1.isChromeDebugger)() ? undefined : utils_1.getRSAKeyPromise,
        libPhoneNumber,
        keySize,
        createEncryptionSessionCache,
        encryptionSessionCacheTTL
    });
};
//# sourceMappingURL=seald-sdk-react-native.js.map